'' VECTORJET v0.0
'' (C)2020 IRQsome Software
'' Display list helper

VAR
  long head ' current write position
  long spaceleft ' how much space left
  long link ' last list link word
PUB start(ptr,size)
  head := ptr
  spaceleft := size
  link := $8080
  longfill(ptr,0,3) 'invalidate first shape

PUB putlink
  word[link] := head
  link := head
  putword(0)

PUB putlong(x)
  if (spaceleft -= 4) < 0
    abort 1
  'if head & 3
    'abort 2
  long[head] := x
  head += 4

PUB putword(x)
  if (spaceleft -= 2) < 0
    abort 3
  'if head & 1
    'abort 4
  word[head] := x
  head += 2

PUB putbyte(x)
  if (--spaceleft) < 0
    abort 5
  byte[head++] := x

PRI round_f16(x)
  return ((x >> 15)+1)>>1

PUB slopeCalc(x1,x2,y1,y2)

  return ((x1-x2))/(y1.word[1]-y2.word[1]+1)+1

PUB point(x,y,colors) '' HORRIBLY INEFFICIENT FOR TEST USE ONLY

putlink
putword(y.word[1]) ' start line
putword(y.word[1]+1) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused
repeat 2
    putlong(0)
putlong(x)
putlong(x+$10000)
putword(1)
putword(colors)
putlong(0)
putlong(0) 

PUB line(x1,y1,x2,y2,colors) | tmp '' TODO: Add dedicated line shape type?
if y1 > y2
  tmp := y1
  y1 := y2
  y2 := tmp
  
  tmp := x1
  x1 := x2
  x2 := tmp

putlink
putword(y1.word[1]) ' start line
putword(y2.word[1]+1) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused
repeat 2
    putlong(0)
if y2~>16 == y1~>16 ' horizontal line
  if x1 < x2
    putlong(x1)
    putlong(x2)
  else
    putlong(x2)
    putlong(x1)
  putword(1)
  putword(colors)
  putlong(0)
  putlong(0)
else
  tmp := slopeCalc(x2,x1,y2,y1) 
  if x1 =< x2
    putlong(x1)
    putlong(x1+tmp+$10000)
  else
    putlong(x1+tmp-$10000)
    putlong(x1)
   
  putword((y2.word[1])-(y1.word[1])+1)
  putword(colors)
   
  putlong(tmp)
  putlong(tmp)





PUB line_triangle(x1,y1,x2,y2,x3,y3,colors)
  line(x1,y1,x2,y2,colors)
  line(x1,y1,x3,y3,colors)
  line(x2,y2,x3,y3,colors)

PUB line_polygon(polyptr,vcount,colors) | i,px,py
  poly_ysort(polyptr,vcount)'' sorting magic
  px := long[polyptr][(vcount<<1)-2]
  py := long[polyptr][(vcount<<1)-1]  
  repeat i from 0 to vcount-1
    line(px,py,px := long[polyptr][(i<<1)],py := long[polyptr][(i<<1)+1],colors) 

PUB triangle(x1,y1,x2,y2,x3,y3,colors) | tmp,tmp2,tmp3

if y1 > y2
  tmp := y1
  y1 := y2
  y2 := tmp
  
  tmp := x1
  x1 := x2
  x2 := tmp
  
if y1 > y3
  tmp := y1
  y1 := y3
  y3 := tmp
  
  tmp := x1
  x1 := x3
  x3 := tmp
  
if y2 > y3
  tmp := y2
  y2 := y3
  y3 := tmp
  
  tmp := x2
  x2 := x3
  x3 := tmp

if y2~>16 == y1~>16 AND y2~>16 == y3~>16
    return ' reject degenerate triangle

putlink
putword(y1.word[1]) ' start line
putword(y3.word[1]+1) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused

if y2~>16 == y3~>16 ' bottom flat?
  
  'pst.str(string("bottom flat",13)) 
  repeat 2
    putlong(0)
  tmp := slopeCalc(x3,x1,y3,y1)
  tmp2:= slopeCalc(x2,x1,y2,y1)
  if x2 > x3    
    putlong(x1+(tmp<#0))
    putlong(x1+(tmp2#>0))
  else    
    putlong(x1+(tmp2<#0))
    putlong(x1+(tmp#>0))

  putword((y3.word[1])-(y1.word[1])+1)
  putword(colors)
  if x2 > x3
    putlong(tmp)
    putlong(tmp2)
  else                                          
    putlong(tmp2)
    putlong(tmp) 

elseif y1~>16 == y2~>16 ' top flat?
  'pst.str(string("top flat",13))
  
  repeat 2
    putlong(0)

  tmp := slopeCalc(x3,x2,y3,y2)
  tmp2:= slopeCalc(x3,x1,y3,y1)
  if x1 > x2
    putlong(x2+(tmp<#0))
    putlong(x1+(tmp2#>0))
  else
    putlong(x1+(tmp2<#0))
    putlong(x2+(tmp#>0))
    
  putword((y3.word[1])-(y1.word[1])+1)
  putword(colors)
  

  if x1 > x2
    putlong(tmp)
    putlong(tmp2)
  else
    putlong(tmp2)
    putlong(tmp)

else
  'pst.str(string("other",13))
  
  repeat 2
    putlong(0)

  tmp := slopeCalc(x3,x1,y3,y1) ' long slope
  tmp2 := slopeCalc(x2,x1,y2,y1)' short slope
  if tmp2 > tmp
    putlong(x1+(tmp<#0))
    putlong(x1+(tmp2#>0))
    putword((y2.word[1])-(y1.word[1]))
    'putword($CCCC)
    putword(colors)
    
    putlong(tmp)
    putlong(tmp2)   
  else
    putlong(x1+(tmp2<#0))
    putlong(x1+(tmp#>0))
    putword((y2.word[1])-(y1.word[1]))
    'putword($CCCC)
    putword(colors)
    
    putlong(tmp2)
    putlong(tmp) 
  
  putword((y3.word[1])-(y2.word[1])+1)
  'putword($4C4C)
  putword(colors)

  tmp3 := slopeCalc(x3,x2,y3,y2) 
  if tmp2 > tmp
    putlong(tmp)
    putlong(tmp3)
  else
    putlong(tmp3)
    putlong(tmp)    

PRI poly_ysort(arr,length) : i | j,i2,zone,arrend,k,realsize,subsize,sizze,temp[2]

  repeat i from 0 to length-1 '' insert original vertex ID into low word of Y
    word[arr+(i<<3)][2] := i 

  '' Non-recursive in-place sorting algorithm
  '' As relayed to me by a friendly Discord user
  '' (ported to spin and optimized by me)
  subsize := 8
  length *= 8
  arrend := arr+length
  repeat while subsize < length
    sizze := subsize<<1
    repeat i from arr to arrend-8 step sizze
      j := i+subsize
      realsize := sizze <# (arrend-i)
      i2 := i
      repeat k from 0 to realsize-8 step 8
        if j => (i+realsize) or i2 => j
          'pass
        elseif long[i2][1] =< long[j][1]'compareNames(arr+i2,arr+j) =< 0
          i2 += 8
        else 
          zone := j
          repeat           
            if (zone+8) == (i+realsize) or long[(zone+8)][1] =< long[i2][1]'compareNames(arr+(zone+8),arr+i2) > 0
              longmove(@temp, i2,2)
              longmove(i2,j,2)
              longmove(j,j+8,(zone-j)>>2)
              longmove(zone,@temp,2)
              if j == zone
                i2 += 8
              else
                k -= 8
              quit   
            zone += 8
    subsize := sizze
CON POLY_MAXV = 16
PUB polygon(polyptr,vcount,colors) |tmp,i2,left,right,stepy,ytop,ybottom,sideboundary,prevy,leftslope,rightslope,lefty,righty,topleft,topright,leftbehind,rightbehind,topptr

poly_ysort(polyptr,vcount)'' sorting magic
 
ytop := long[polyptr][1]~>16
ybottom:= long[polyptr][(vcount<<1)-1]~>16
sideboundary := word[polyptr][(vcount<<1)-1]*2 ' original ID of bottom-most vertex
 
if ytop == ybottom
  return

 
putlink
putword(ytop) ' start line
putword(ybottom+1) ' end line
putword(-1) ' init sync to -1
putbyte(1) ' type
putbyte(0) ' unused
putword(0) ' unused

repeat 2
  putlong(0) ' scratch space


'' find top of stack
i2:=0
lefty:=righty:=prevy:=ytop
topleft:=posx
topright:=negx
repeat while (long[polyptr][i2+1]~>16) == ytop
  tmp:=long[polyptr][i2]
  topleft  <#=tmp
  topright #>=tmp 
  i2+=2
'' consumed all top vertices

'' initialize top edges - slopes will be added on later
topptr:=head
putlong(topleft)
putlong(topright)

'putword(ybottom-ytop+1)
'putword(colors)
'putlong(0)
'putlong(0)



leftslope:=rightslope:=negx

'' run through all that is left
stepy:= long[polyptr][i2+1]~>16
leftbehind~
rightbehind~
repeat
  if i2 == vcount<<1
    quit                         
  left:=posx
  right:=negx
  repeat while (long[polyptr][i2+1]~>16) == stepy ' find all vertices on this y
    if i2 => sideboundary ' left side?
      left <#= long[polyptr][i2]
    else ' right side?
      right #>= long[polyptr][i2]
    i2+=2
       
  ifnot left == posx
    tmp := leftslope == negx 
    leftslope := slopeCalc(left,topleft,lefty,stepy)
    if tmp
      'long[topptr] += leftslope
    topleft := left
    lefty:=stepy 
    tmp := head-8 ' previous left slope field
    repeat leftbehind
      'long[tmp]:=leftslope
      tmp -= 12  
  else
    leftbehind++
    
  ifnot right == negx
    tmp := rightslope == negx
    rightslope := slopeCalc(right,topright,righty,stepy)
    if tmp
      'long[topptr][1] += rightslope
    topright := right
    righty:=stepy
    tmp := head-4 ' previous right slope field
    repeat rightbehind
      'long[tmp]:=rightbehind
      tmp -= 12 
  else
    rightbehind++    
  putword(stepy-prevy)
  putword(colors)
  putlong(leftslope)
  putlong(rightslope)

  prevy := stepy
  stepy:= long[polyptr][i2+1]~>16
     



  

  